package cn.com.infosec.math.ec;

import cn.com.infosec.util.Arrays;
import java.math.BigInteger;

class IntArray {
   private int[] m_ints;

   public IntArray(int intLen) {
      this.m_ints = new int[intLen];
   }

   public IntArray(int[] ints) {
      this.m_ints = ints;
   }

   public IntArray(BigInteger bigInt) {
      this(bigInt, 0);
   }

   public IntArray(BigInteger bigInt, int minIntLen) {
      if (bigInt.signum() != -1) {
         if (bigInt.equals(ECConstants.ZERO)) {
            this.m_ints = new int[1];
         } else {
            byte[] bigInt1;
            byte[] var10000 = bigInt1 = bigInt.toByteArray();
            int var3 = var10000.length;
            int var4 = 0;
            if (var10000[0] == 0) {
               --var3;
               var4 = 1;
            }

            int var5;
            if ((var5 = (var3 + 3) / 4) < minIntLen) {
               this.m_ints = new int[minIntLen];
            } else {
               this.m_ints = new int[var5];
            }

            minIntLen = var5 - 1;
            int var10001 = var3 = var3 % 4 + var4;
            var5 = 0;
            int var6;
            if (var4 < var10001) {
               while(var4 < var3) {
                  var5 <<= 8;
                  if ((var6 = bigInt1[var4]) < 0) {
                     var6 += 256;
                  }

                  var5 |= var6;
                  ++var4;
               }

               var10001 = minIntLen;
               minIntLen += -1;
               this.m_ints[var10001] = var5;
            }

            while(minIntLen >= 0) {
               var3 = 0;

               for(var5 = 0; var5 < 4; var4 = var6) {
                  var3 <<= 8;
                  var6 = var4 + 1;
                  if ((var4 = bigInt1[var4]) < 0) {
                     var4 += 256;
                  }

                  var3 |= var4;
                  ++var5;
               }

               this.m_ints[minIntLen] = var3;
               --minIntLen;
            }

         }
      } else {
         throw new IllegalArgumentException("Only positive Integers allowed");
      }
   }

   private int[] resizedInts(int newLen) {
      IntArray var10000 = this;
      int[] var4 = new int[newLen];
      int[] var2;
      int var3;
      if ((var3 = (var2 = var10000.m_ints).length) >= newLen) {
         var3 = newLen;
      }

      System.arraycopy(var2, 0, var4, 0, var3);
      return var4;
   }

   public boolean isZero() {
      int[] var1;
      return (var1 = this.m_ints).length == 0 || var1[0] == 0 && this.getUsedLength() == 0;
   }

   public int getUsedLength() {
      int[] var1;
      int var2;
      if ((var2 = (var1 = this.m_ints).length) < 1) {
         return 0;
      } else if (var1[0] != 0) {
         while(this.m_ints[var2 += -1] == 0) {
         }

         return var2 + 1;
      } else {
         while(this.m_ints[var2 += -1] == 0) {
            if (var2 <= 0) {
               return 0;
            }
         }

         return var2 + 1;
      }
   }

   public int bitLength() {
      int var1;
      if ((var1 = this.getUsedLength()) == 0) {
         return 0;
      } else {
         int var2 = var1 - 1;
         int var3 = var1 = this.m_ints[var2];
         var2 = (var2 << 5) + 1;
         if ((var3 & -65536) != 0) {
            if ((var1 & -16777216) != 0) {
               var2 += 24;
               var1 >>>= 24;
            } else {
               var2 += 16;
               var1 >>>= 16;
            }
         } else if (var1 > 255) {
            var2 += 8;
            var1 >>>= 8;
         }

         while(var1 != 1) {
            ++var2;
            var1 >>>= 1;
         }

         return var2;
      }
   }

   public BigInteger toBigInteger() {
      int var1;
      if ((var1 = this.getUsedLength()) == 0) {
         return ECConstants.ZERO;
      } else {
         int var2;
         int var3 = this.m_ints[var2 = var1 - 1];
         byte[] var4 = new byte[4];
         int var5 = 0;
         boolean var6 = false;

         int var9;
         for(int var7 = 3; var7 >= 0; var5 = var9) {
            byte var8 = (byte)(var3 >>> var7 * 8);
            if (!var6 && var8 == 0) {
               var9 = var5;
            } else {
               var6 = true;
               var9 = var5 + 1;
               var4[var5] = var8;
            }

            --var7;
         }

         byte[] var10 = new byte[var2 * 4 + var5];

         for(var2 = 0; var2 < var5; ++var2) {
            var10[var2] = var4[var2];
         }

         var1 -= 2;

         for(var3 = var1; var3 >= 0; var3 = var1) {
            for(var1 = 3; var1 >= 0; --var1) {
               var10[var5++] = (byte)(this.m_ints[var3] >>> var1 * 8);
            }

            var1 = var3 + -1;
         }

         return new BigInteger(1, var10);
      }
   }

   public void shiftLeft() {
      int var1;
      if ((var1 = this.getUsedLength()) != 0) {
         int[] var2;
         if ((var2 = this.m_ints)[var1 - 1] < 0 && ++var1 > var2.length) {
            this.m_ints = this.resizedInts(var2.length + 1);
         }

         boolean var6 = false;

         boolean var5;
         for(int var3 = 0; var3 < var1; var6 = var5) {
            int[] var4;
            if ((var4 = this.m_ints)[var3] < 0) {
               var5 = true;
            } else {
               var5 = false;
            }

            var4[var3] <<= 1;
            if (var6) {
               var4[var3] |= 1;
            }

            ++var3;
         }

      }
   }

   public IntArray shiftLeft(int n) {
      int var2;
      if ((var2 = this.getUsedLength()) == 0) {
         return this;
      } else if (n == 0) {
         return this;
      } else if (n > 31) {
         throw new IllegalArgumentException("shiftLeft() for max 31 bits , " + n + "bit shift is not possible");
      } else {
         int[] var3;
         int[] var10000 = var3 = new int[var2 + 1];
         int var4 = 32 - n;
         var10000[0] = this.m_ints[0] << n;

         for(int var5 = 1; var5 < var2; ++var5) {
            int[] var6;
            var3[var5] = (var6 = this.m_ints)[var5] << n | var6[var5 - 1] >>> var4;
         }

         var3[var2] = this.m_ints[var2 - 1] >>> var4;
         return new IntArray(var3);
      }
   }

   public void addShifted(IntArray param1, int param2) {
      // $FF: Couldn't be decompiled
   }

   public int getLength() {
      return this.m_ints.length;
   }

   public boolean testBit(int n) {
      IntArray var10000 = this;
      int var2 = n >> 5;
      n = 1 << (n & 31);
      return (var10000.m_ints[var2] & n) != 0;
   }

   public void flipBit(int n) {
      IntArray var10000 = this;
      int var2 = n >> 5;
      n = 1 << (n & 31);
      int[] var3 = var10000.m_ints;
      var3[var2] ^= n;
   }

   public void setBit(int n) {
      IntArray var10000 = this;
      int var2 = n >> 5;
      n = 1 << (n & 31);
      int[] var3 = var10000.m_ints;
      var3[var2] |= n;
   }

   public IntArray multiply(IntArray other, int m) {
      int var3 = m + 31 >> 5;
      if (this.m_ints.length < var3) {
         this.m_ints = this.resizedInts(var3);
      }

      IntArray var4;
      var4 = new IntArray.<init>(other.resizedInts(other.getLength() + 1));
      other = new IntArray.<init>(m + m + 31 >> 5);
      m = 1;

      for(int var5 = 0; var5 < 32; ++var5) {
         for(int var6 = 0; var6 < var3; ++var6) {
            if ((this.m_ints[var6] & m) != 0) {
               other.addShifted(var4, var6);
            }
         }

         m <<= 1;
         var4.shiftLeft();
      }

      return other;
   }

   public void reduce(int m, int[] redPol) {
      for(int var3 = m + m - 2; var3 >= m; --var3) {
         if (this.testBit(var3)) {
            int var4;
            this.flipBit(var4 = var3 - m);
            this.flipBit(var3);
            int var5 = redPol.length;

            while((var5 += -1) >= 0) {
               this.flipBit(redPol[var5] + var4);
            }
         }
      }

      this.m_ints = this.resizedInts(m + 31 >> 5);
   }

   public IntArray square(int m) {
      int[] m1;
      int[] var10002 = m1 = new int[16];
      var10002[1] = 1;
      var10002[2] = 4;
      var10002[3] = 5;
      var10002[4] = 16;
      var10002[5] = 17;
      var10002[6] = 20;
      var10002[7] = 21;
      var10002[8] = 64;
      var10002[9] = 65;
      var10002[10] = 68;
      var10002[11] = 69;
      var10002[12] = 80;
      var10002[13] = 81;
      var10002[14] = 84;
      var10002[15] = 85;
      int var2 = m + 31 >> 5;
      if (this.m_ints.length < var2) {
         this.m_ints = this.resizedInts(var2);
      }

      IntArray var3;
      var3 = new IntArray.<init>(var2 + var2);

      for(int var4 = 0; var4 < var2; ++var4) {
         int var5 = 0;

         int var6;
         for(var6 = 0; var6 < 4; ++var6) {
            var5 = var5 >>> 8 | m1[this.m_ints[var4] >>> var6 * 4 & 15] << 24;
         }

         int var7;
         var3.m_ints[var7 = var4 + var4] = var5;
         var5 = 0;
         int var8 = this.m_ints[var4] >>> 16;

         for(var6 = 0; var6 < 4; ++var6) {
            var5 = var5 >>> 8 | m1[var8 >>> var6 * 4 & 15] << 24;
         }

         var3.m_ints[var7 + 1] = var5;
      }

      return var3;
   }

   public boolean equals(Object o) {
      if (!(o instanceof IntArray)) {
         return false;
      } else {
         IntArray o1 = (IntArray)o;
         int var2 = this.getUsedLength();
         if (o1.getUsedLength() != var2) {
            return false;
         } else {
            for(int var3 = 0; var3 < var2; ++var3) {
               if (this.m_ints[var3] != o1.m_ints[var3]) {
                  return false;
               }
            }

            return true;
         }
      }
   }

   public int hashCode() {
      int var1 = this.getUsedLength();
      int var2 = 1;

      for(int var3 = 0; var3 < var1; ++var3) {
         var2 = var2 * 31 + this.m_ints[var3];
      }

      return var2;
   }

   public Object clone() {
      return new IntArray(Arrays.clone(this.m_ints));
   }

   public String toString() {
      int var1;
      if ((var1 = this.getUsedLength()) == 0) {
         return "0";
      } else {
         StringBuffer var2;
         var2 = new StringBuffer.<init>(Integer.toBinaryString(this.m_ints[var1 - 1]));

         for(var1 -= 2; var1 >= 0; --var1) {
            String var3;
            for(int var4 = (var3 = Integer.toBinaryString(this.m_ints[var1])).length(); var4 < 8; ++var4) {
               var3 = "0" + var3;
            }

            var2.append(var3);
         }

         return var2.toString();
      }
   }
}
